Package twisted :: Package python :: Module usage :: Class Options

[frames | no frames]

## Class Options

    dict --+
           |
          Options

Known Subclasses:
  `ConvertOptions`, `FirstPassOptions`, `GeneralOptions`, `MyOptions`, `MyOptions`, `Options`, `Options`, `Options`, `Options`, `Options`, `Options`, `Options`, `Options`, `Options`, `Options`, `Options`, `Options`, `Options`, `Options`, `Options`, `Options`, `Options`, `ServerOptions`, `TkunzipOptions`

An option list parser class

`optFlags` and `optParameters` are lists of available parameters which your program can handle. The difference between the two is the 'flags' have an on(1) or off(0) state (off by default) whereas 'parameters' have an assigned value, with an optional default. (Compare '--verbose' and '--verbosity=2')

optFlags is assigned a list of lists. Each list represents a flag parameter, as so:

| optFlags = [['verbose', 'v', 'Makes it tell you what it doing.'], | ['quiet', 'q', 'Be vewy vewy quiet.']]

As you can see, the first item is the long option name (prefixed with '--' on the command line), followed by the short option name (prefixed with '-'), and the description. The description is used for the built-in handling of the --help switch, which prints a usage summary.

`optParameters` is much the same, except the list also contains a default value:

| optParameters = [['outfile', 'O', 'outfile.log', 'Description...']]

subCommands is a list of 4-tuples of (command name, command shortcut, parser class, documentation). If the first non-option argument found is one of the given command names, an instance of the given parser class is instantiated and given the remainder of the arguments to parse and self.opts[command] is set to the command name. For example:

| subCommands = [ | ['inquisition', 'inquest', InquisitionOptions, 'Perform an inquisition'], | ['holyquest', 'quest', HolyQuestOptions, 'Embark upon a holy quest'] | ]

In this case, `"<program> holyquest --horseback --for-grail"` will cause `HolyQuestOptions` to be instantiated and asked to parse `['--horseback', '--for-grail']`. Currently, only the first sub-command is parsed, and all options following it are passed to its parser. If a subcommand is found, the subCommand attribute is set to its name and the subOptions attribute is set to the Option instance that parses the remaining options. If a subcommand is not given to parseOptions, the subCommand attribute will be None. You can also mark one of the subCommands to be the default.

| defaultSubCommand = 'holyquest'

In this case, the subCommand attribute will never be None, and the subOptions attribute will always be set.

If you want to handle your own options, define a method named `opt_paramname` that takes `(self, option)` as arguments. `option` will be whatever immediately follows the parameter on the command line. Options fully supports the mapping interface, so you can do things like `'self["option"] = val'` in these methods.

Advanced functionality is covered in the howto documentation, available at http://twistedmatrix.com/documents/howto/options, or doc/howto/options.html in your Twisted directory.

Method Summary
| `__init__(self)`
| `__hash__(self)`
| `__str__(self, width)`
| ``_gather_flags`(self)` Gather up boolean (flag) options.
| ``_gather_handlers`(self)` Gather up options with their own handler methods.
| ``_gather_parameters`(self)` Gather options which take a value.
| `_generic_flag(self, flagName, value)`
| `_generic_parameter(self, parameterName, value)`
| `getSynopsis(self)`
| `getUsage(self, width)`
| ``opt_help`(self)` Display this help and exit.
| `opt_version(self)`
| ``parseArgs`(self)` I am called with any leftover arguments which were not options.
| ``parseOptions`(self, options)` The guts of the command-line parser.
| ``postOptions`(self)` I am called after the options are parsed.
Inherited from dict
| `__cmp__(...)`
| `__contains__(...)`
| `__delitem__(...)`
| `__eq__(...)`
| `__ge__(...)`
| `__getattribute__(...)`
| `__getitem__(...)`
| `__gt__(...)`
| `__iter__(...)`
| `__le__(...)`
| `__len__(...)`
| `__lt__(...)`
| `__ne__(...)`
| `__repr__(...)`
| `__setitem__(...)`
| `clear(...)`
| `copy(...)`
| `get(...)`
| `has_key(...)`
| `items(...)`
| `iteritems(...)`
| `iterkeys(...)`
| `itervalues(...)`
| `keys(...)`
| `popitem(...)`
| `setdefault(...)`
| `update(...)`
| `values(...)`
Inherited from object
| `__delattr__(...)`
| `__reduce__(...)`
| `__setattr__(...)`
Inherited from type
| `__new__(...)`

Class Variable Summary
`NoneType` | `defaultSubCommand` = None
`NoneType` | `parent` = None
`NoneType` | `subCommand` = None

Method Details

### _gather_flags(self)

Gather up boolean (flag) options.

### _gather_handlers(self)

Gather up options with their own handler methods.

### _gather_parameters(self)

Gather options which take a value.

### opt_help(self)

Display this help and exit.

### parseArgs(self)

I am called with any leftover arguments which were not options.

Override me to do something with the remaining arguments on the command line, those which were not flags or options. e.g. interpret them as a list of files to operate on.

Note that if there more arguments on the command line than this method accepts, parseArgs will blow up with a getopt.error. This means if you don't override me, parseArgs will blow up if I am passed any arguments at all!

### parseOptions(self, options=None)

The guts of the command-line parser.

### postOptions(self)

I am called after the options are parsed.

Override this method in your subclass to do something after the options have been parsed and assigned, like validate that all options are sane.

Class Variable Details

### defaultSubCommand

  Type:
    `NoneType`
  Value:

        None

### parent

  Type:
    `NoneType`
  Value:

        None

### subCommand

  Type:
    `NoneType`
  Value:

        None

Generated by Epydoc 2.0 on Sat May 15 20:08:18 2004 | http://epydoc.sf.net